/**
 * Created by Administrator on 2015/8/20.
 */
function CocosHeler()
{

}

CocosHeler.getDesignResolutionMode = function()
{
    var mode = cc.sys.isMobile?cc.ResolutionPolicy.EXACT_FIT:cc.ResolutionPolicy.SHOW_ALL;
    return mode;
}

CocosHeler.runAnimation = function(wiget,actionFile,actionName,forever)
{
    forever = forever || false;
    var action = ccs.load(actionFile).action;
    action.play(actionName,forever);
    return wiget.runAction(action)

}

CocosHeler.runSceneAnimation = function(wiget,action,actionName,forever)
{
    forever = forever || false;
    action.play(actionName,forever);
    return wiget.runAction(action)
}

CocosHeler.connectAction = function(wiget,actionFile)
{
    var action = ccs.load(actionFile).action;
    wiget.runAction(action);
    return action;
}


CocosHeler.setOnClickEvent = function(wiget,callBack,content)
{
    wiget.addTouchEventListener(function(select,type)
    {
        switch(type)
        {
            case ccui.Widget.TOUCH_BEGAN :
                callBack.call(content,wiget);
                return true;
        }
    },this);
}

CocosHeler.setSelectEvent = function(checkBox,selectEvent)
{
    checkBox.addEventListener(function(sender, type)
    {
        switch (type)
        {
            case ccui.CheckBox.EVENT_SELECTED:
                selectEvent(true);
                break;
            case ccui.CheckBox.EVENT_UNSELECTED:
                selectEvent(false);
                break;
            default:
                break;
        }
    });
}

CocosHeler.touchInSprite = function(touch,sprite)
{
    var locationInNode = sprite.convertToNodeSpace(touch.getLocation());
    var s = sprite.getContentSize();
    var rect = cc.rect(0, 0, s.width, s.height);
    if (cc.rectContainsPoint(rect, locationInNode))
    {
        return true;
    }
    return false;
}

CocosHeler.setEventListener = function(sprite,onTouchBegin,onTouchEnd,onTouchMove)
{
        var listener = cc.EventListener.create({
            event: cc.EventListener.MOUSE, //TOUCH_ONE_BY_ONE 为单次触摸事件监听器
            swallowTouches: true,
            onTouchBegan: function (touch, event) {
                if(typeof onTouchBegin != "undefined")
                {
                    var target = event.getCurrentTarget();
                    if(CocosHeler.touchInSprite(touch,target))
                    {
                        console.log(target.TestName);
                        onTouchBegin(target,touch,event)
                        return  true;
                    }
                }
                return false;
            },
            onTouchEnded: function (touch, event)
            {
                if(typeof onTouchEnd != "undefined")
                {
                    var target = event.getCurrentTarget();
                    onTouchEnd(target,touch,touch);
                }
                return false;
            },
            onTouchMoved:function(touch, event)
            {
                if(typeof onTouchMove != "undefined")
                {
                    var target = event.getCurrentTarget();
                    onTouchMove(target,touch,event);
                }
                console.log(event.getCurrentTarget().TestName)
                return false;
            }
        });
    cc.eventManager.addListener(listener, sprite);
}

//更新水平方向的Margin
CocosHeler.UpdateMarginX = function(childArray,layer)
{
    var currentX = 0;
    var childs = childArray;
    var zIndex = 0;
    for(var key in childs)
    {
        var oneChild = childs[key];
        currentX+=oneChild.MarginLeft;
        oneChild.setPositionX(currentX);
        oneChild.setLocalZOrder(zIndex);
        currentX+=oneChild.MarginRight;
        zIndex+=1;
    }
}

CocosHeler.centerMarginChilds = function(childArray,layer)
{
    var childs = childArray;
    var count = childs.length;
    var maxDistance = 0;
    var minStart = 0;
    for(var key in childs)
    {
        var oneChild = childs[key];
        var oneChildX =  oneChild.getPositionX();
        var oneChildWidth = oneChild.getContentSize().width;
        var oneChildDistance = oneChildX+oneChildWidth;
        maxDistance = maxDistance>oneChildDistance?maxDistance:oneChildDistance;
        minStart = minStart>oneChildX?oneChildX:minStart;
    }

    var length = maxDistance -minStart;

    var layerWidth = layer.getContentSize().width;

    var centerX = (layerWidth - length)/2.0;

    var deltaX = centerX - minStart;

    for(var key in childs)
    {
        var oneChild = childs[key];
        var x = oneChild.getPositionX()+deltaX;
        oneChild.setPositionX(x);
    }
}

CocosHeler.centerMarginChildsNotCrossLeft = function(childArray,layer)
{
    var childs = childArray;
    var count = childs.length;
    var maxDistance = 0;
    var minStart = 0;
    for(var key in childs)
    {
        var oneChild = childs[key];
        var oneChildX =  oneChild.getPositionX();
        var oneChildWidth = oneChild.getContentSize().width;
        var oneChildDistance = oneChildX+oneChildWidth;
        maxDistance = maxDistance>oneChildDistance?maxDistance:oneChildDistance;
        minStart = minStart>oneChildX?oneChildX:minStart;
    }

    var length = maxDistance -minStart;

    var layerWidth = layer.getContentSize().width;

    var centerX = (layerWidth - length)/2.0;
    centerX = centerX<0?0:centerX;
    var deltaX = centerX - minStart;

    for(var key in childs)
    {
        var oneChild = childs[key];
        oneChild.setPositionX(oneChild.getPositionX()+deltaX);
    }
}