/**
 * Created by Administrator on 2015/8/28.
 */
//这个类主要用来帮助计算游戏中的扑克相关的算法

function GameHelper()
{

}

GameHelper.CardType =
{'1':1,//黑桃
    '2':2,//方片
    '3':3,//梅花
    '4':4,//红桃
    '5':5};//王子

GameHelper.TypePower  =
{
    '1':0,//普通牌
    '2':42,//普通主
    '3':98,//常主
    '4':142,//打的主
    '5':198//王
};

GameHelper.ColorPower =
{
    '1':0,
    '2':14,
    '3':28,
    '4':42,
    '5':43,
    '6':60
};

GameHelper.InitColorPower =
{
    '1':0,
    '2':14,
    '3':28,
    '4':42,
    '5':43,
    '6':60
};

GameHelper.CardNumPower =
{
    '1':14,
    '2':2,
    '3':3,
    '4':4,
    '5':5,
    '6':6,
    '7':7,
    '8':8,
    '9':9,
    '10':10,
    '11':11,
    '12':12,
    '13':13
};

//初始化Gamehelper
GameHelper.init = function()
{
    //创建一个162张牌的数组
    var cards = GameHelper.cards3 = [];
    for(var i = 0;i<162;i++)
    {
        cards[i] = (i+1);
    }
}

//发牌钱使用
//通过主的类型，修改ColorPower
GameHelper.changeBlackAndRed = function(mainType)
{
    var j = mainType;
   for(var i = 1;i<=4;i++)
   {
       GameHelper.ColorPower[j] = GameHelper.InitColorPower[i];
       j+=1;
       j = j>4?1:j;
   }
}



//162张牌的index，获取其真正的大小
GameHelper.getCard = function(cardIndex)
{
    var card = new Card();
    var oneCardIndex = cardIndex % 54;
    oneCardIndex = (oneCardIndex == 0 ? 54 : oneCardIndex);
    card.cardNum = oneCardIndex % 13;
    card.cardNum = (card.cardNum == 0 ? 13 : card.cardNum);
    var cardType = parseInt(oneCardIndex / 13);
    if (card.cardNum == 13) cardType = cardType - 1;
    card.cardType = (cardType + 1);
    return card;
}

//得到牌的权重
GameHelper.getPower =  function(card,mainType,keyNum)
{
    //计算这张卡片的权重
    var typePower = 0;
    var colorPower = 0;
    var numPower = 0;
    //首先计算出卡片的类型权重
    //王
    //普通牌
    if (card.cardType != mainType && card.cardNum != keyNum && card.cardNum != 2 && card.cardType != GameHelper.CardType['5'])
    {
        typePower = GameHelper.TypePower['1'];
    }
    else
    //普通主
    if (card.cardType == mainType && card.cardNum != keyNum && card.cardNum != 2)
    {
        typePower = GameHelper.TypePower['2'];
    }
    else
    //常主
    if (card.cardNum == 2 && card.cardType != GameHelper.CardType['5'])
    {
        typePower = GameHelper.TypePower['3'];
    }
    else
    //打的主
    if (card.cardNum == keyNum &&  card.cardType != 5 )
    {
        typePower = GameHelper.TypePower['4'];
    }
    else

    if (card.cardType == GameHelper.CardType['5'])
    {
        typePower = GameHelper.TypePower['5'];
    }

    //计算出颜色的权重
    if (card.cardType == mainType)
    {
        colorPower = GameHelper.ColorPower['5'];
    }
    else
    {
        colorPower =  GameHelper.ColorPower[card.cardType];
    }
    //计算牌大小的权重
    numPower = GameHelper.CardNumPower[card.cardNum];

    var finalPower = typePower + colorPower + numPower;
    return finalPower;
}



//分配4个人的牌
GameHelper.getAssignCard = function()
{
    var cards = GameHelper.getRandomCards();
    var assignCars = new AssignCards();

    //生成四个人的牌和底牌
    var currentIndex =1;
    var i = 0;
    var j = 0;
    for (i = 0,currentIndex = 0;i<=155;i+=4,currentIndex++)
    {
        for (j = 0;j<4;j++)
        {
            var cardIndex =  cards[i+j];
            assignCars.assignCars[j][currentIndex] = cardIndex;
        }
    }
    for (i = 156,j = 0;i<=161;i++,j++)//底牌
    {
        assignCars.remain[j] = cards[i];
    }
    return assignCars;
}

//随机生成一副牌
GameHelper.getRandomCards = function()
{
    var cards = GameHelper.cards3;
    for(var i = 0;i<162;i++)
    {
        var randomIndex = GameHelper.randomInt(0,161);
        var temp = cards[i];
        cards[i] = cards[randomIndex];
        cards[randomIndex] = temp;
    }
    return cards;
}

//随机产生区间的数
GameHelper.randomInt = function(min,max)
{
    var length = max - min;
    var random = Math.floor(Math.random()*(length+1));
    return min +random;
}

//获得牌的类别，如主，或者其他,便于筛选牌
GameHelper.getCardType = function(cardIndex,keyNum,mainType)
{
    var cctype = 0;
    var card = GameHelper.getCard(cardIndex);
    var cardPower = GameHelper.getPower(card,mainType,keyNum);
    if (cardPower>85)
    {
        cctype = 5;
    }
    else
    {
        cctype  = card.cardType;
    }
    return cctype;
}
GameHelper.getHitCardPower = function(firstCardType,card,keyNum,keyType)
{
    //计算这张卡片的权重
    var  typePower = 0;
    var  colorPower = 0;
    var  numPower = 0;

    //首先计算出卡片的类型权重
    //王

    //普通牌
    if (card.cardType != keyType &&  card.cardNum != keyNum && card.cardNum !=2 && card.cardType != 5)
    {
        typePower = GameHelper.TypePower[1];
    }else
    //普通主
    if (card.cardType == keyType && card.cardNum != keyNum && card.cardNum != 2)
    {
        typePower = GameHelper.TypePower[2];
    }else
    //常主
    if (card.cardNum == 2 && card.cardType != 5)
    {
        typePower = GameHelper.TypePower[3];
    }else
    //打的主
    if (card.cardNum == keyNum && card.cardType != 5)
    {
        typePower = GameHelper.TypePower[4];
    }else

    if (card.cardType == 5)
    {
        typePower = GameHelper.TypePower[5];
    }

    //计算出颜色的权重
    if (card.cardType == keyType)
    {
        colorPower =  GameHelper.ColorPower[5];
    }
    else
    {

        if (card.cardType == firstCardType && card.cardType != keyType && card.cardNum != keyNum && card.cardNum != 2)//必须判断不是主的情况，如果是主，第一个是一个副，那么出牌的时候，都是副3，与第一个副的类型就有关系了
        {
            colorPower = 42;
        }
        else
        {
            colorPower = 0;
        }

    }
    if(card.cardType == 5)
    {
        colorPower = 0;
    }
    //计算牌大小的权重
    numPower = GameHelper.CardNumPower[card.cardNum];

    var  finalPower = typePower + colorPower + numPower;
    return finalPower;
}
GameHelper.getNextPos = function(pos)
{
    var  posIndexArray = {top:0,left:1,bottom:2,right:3};
    var posArray = ['top','left','bottom','right'];
    var posIndex = posIndexArray[pos];
    posIndex+=1;
    posIndex = posIndex>3?0:posIndex;
    return posArray[posIndex];
}

GameHelper.isSameCard = function(cardIndexArray)
{

    var firstCard = GameHelper.getCard(cardIndexArray[0]);

    for(var i = 1;i<cardIndexArray.length;i++)
    {
        var oneCard = GameHelper.getCard(cardIndexArray[i]);
        if(firstCard.cardType == oneCard.cardType && firstCard.cardNum == oneCard.cardNum)
        {
            continue;
        }
        else
        {
            return false;
        }
    }

    return true;
}

GameHelper.checkWhoBig = function(firstHitCardPos,hitCardPosArray,keyNum,mainType)
{
    //第一个出牌的牌
    var firstHitCardIndexs = hitCardPosArray[firstHitCardPos];
    var firstCard = GameHelper.getCard(firstHitCardIndexs[0]);
    var maxHitCardPower = GameHelper.getHitCardPower(firstCard.cardType,firstCard,keyNum,mainType);

    var hitCardNum = firstHitCardIndexs.length;

    var currentCom = firstHitCardPos;//为了计算每一个人谁大

    var maxPos = firstHitCardPos;

    var counts = JSUseFullFramework.countJSON(hitCardPosArray);
    for(var i = 0;i<counts-1;i++)
    {
        currentCom = GameHelper.getNextPos(currentCom);
        var hitCards = hitCardPosArray[currentCom];
        //多张牌的情况
        if(hitCardNum>1)
        {

            if(GameHelper.isSameCard(hitCards) == false)continue;
        }
        var currentCardIndex = hitCards[0];
        var currentCard = GameHelper.getCard(currentCardIndex);
        var currentPower = GameHelper.getHitCardPower(firstCard.cardType,currentCard,keyNum,mainType);
        if(currentPower > maxHitCardPower)
        {
            maxPos = currentCom;
            maxHitCardPower = currentPower;
        }
    }
    return maxPos;
}

//数组数组，第一个数组的数全部要，第二个的补齐
GameHelper.combineArray1 = function(requireArray,combinArray,totalNum)
{
    var requireLength = requireArray.length;

    var needCombinNum = totalNum - requireLength;

    var temp = GameHelper.combineArray(combinArray,needCombinNum);

    var finalArray = [];

    for(var key in temp)
    {
        var tp = temp[key];

        var oneA = [];
        for(var key1 in requireArray)
        {
            oneA.push(requireArray[key1]);

        }
        for(var key in tp)
        {
            oneA.push(tp[key]);
        }
        finalArray.push(oneA);
    }
    return finalArray;
}
//给定一个数组，按照给定的组合数，进行组合，比如给定数组123 按两两组合 12 13 23 按3个组合 123
GameHelper.combineArray = function(array,combineNum)
{
    var finalArray = [];
    var youbiao = [];//初始时候游标的值
    var youbiaoValue = [];
    for(var i = 0;i<combineNum;i++)
    {
        youbiao.push(i);
        youbiaoValue.push(i);
    }

    var length = array.length;
    var currentMoveYoubiao = combineNum-1;//比如有3个数，那么就有3个游标,
    var oneCreateCombine = [];

    while(true)
    {
        for(var key in youbiao)
        {
            var oneYoubiao = youbiaoValue[key];
            oneCreateCombine.push(array[oneYoubiao]);
        }
        finalArray.push(oneCreateCombine);
        oneCreateCombine = [];

        //当前游标是否到位
        var moveYoubiaoEndPos = length-1 - (combineNum-1-currentMoveYoubiao);

        var nextPos = youbiaoValue[currentMoveYoubiao]+=1;
        var youbiaoChanged = false;

        while(nextPos > moveYoubiaoEndPos)
        {
            currentMoveYoubiao-=1;
            if(currentMoveYoubiao == -1)return finalArray;

            var currentPos = youbiaoValue[currentMoveYoubiao];
            nextPos = currentPos+=1;
            moveYoubiaoEndPos = length-1 - (combineNum-1-currentMoveYoubiao);

            youbiaoChanged = true;
        }

        //判断最后的游标是否到头，到头后，计算前面的游标
        if(youbiaoChanged == true)
        {
            for(var i = currentMoveYoubiao,j=youbiaoValue[currentMoveYoubiao]+1;i<combineNum;i++,j++)
            {
                youbiaoValue[i] = j;
            }
            currentMoveYoubiao = combineNum -1;

        }
    }
}

//判断一个数组中的牌，是不是都相等
GameHelper.isCardAllSame = function(cardArray)
{
    var first = GameHelper.getCard(cardArray[0]);
    for(var i = 1;i<cardArray.length;i++)
    {
        var oneCard = GameHelper.getCard(cardArray[i]);
        if(first.cardNum != oneCard.cardNum || first.cardType != oneCard.cardType)
        {
            return false;
        }
    }
    return true;
}
//排序这两的数组 [[1,2],[2,3]]，按照从大到小的顺序排列,返回排序好的数组
GameHelper.sortCardArray = function(cardArray,mainType,keyNum)
{
    var finalArray = [];
    var hitCardNum = cardArray[0].length;
    var goodCards = [];
    var otherCards = [];
    if(hitCardNum == 1)
    {
        //直接排序返回
        cardArray = cardArray.sort(function(a,b)
        {
            return (GameHelper.getPower(GameHelper.getCard(a[0]),mainType,keyNum) - GameHelper.getPower(GameHelper.getCard(b[0]),mainType,keyNum));
        });

        finalArray = cardArray;
    }
    else
    {
        //先得到满足出牌要求，比如，是一个对儿的话，就得两张牌都一样
        for(var key in cardArray)
        {
            var oneCards = cardArray[key];
            if(GameHelper.isCardAllSame(oneCards))
            {
                goodCards.push(oneCards);
            }
            else
            {
                otherCards.push(oneCards);
            }
        }

        goodCards = goodCards.sort(function(a,b)
        {
            var aFirst = GameHelper.getCard(a[0]);
            var aPower = GameHelper.getPower(aFirst,mainType,keyNum);
            var bFirst = GameHelper.getCard(b[0]);
            var bPower = GameHelper.getPower(bFirst,mainType,keyNum);

            return aPower - bPower;
        });
        //对于满足出牌要求的进行排序

        otherCards = otherCards.sort(function(a,b)
        {
            var aPowers = 0;
            for(var key in a)
            {
                aPowers+=GameHelper.getPower(GameHelper.getCard(a[key]),mainType,keyNum);
            }

            var bPowers = 0;
            for(var key in b)
            {
                bPowers+=GameHelper.getPower(GameHelper.getCard(b[key]),mainType,keyNum);
            }

            return aPowers - bPowers;
        });

        //对于剩下的进行排序

        for(var key in goodCards)
        {
            finalArray.push(goodCards[key]);
        }

        for(var key in otherCards)
        {
            finalArray.push(otherCards[key]);
        }
    }
    return finalArray;
}

//出牌提示,分为第一次出牌或者是根据第一个出牌的玩家出牌,生成一个index
GameHelper.tipCards = function(isFirst,currentCards,tempCardIndex,cardNum,mainType,keyNum)
{
    var canHitCards = [];//最终所有可以出牌的数组

    var typeIndexMap = {};//其中的key用type和Index合并的数字表示，比如大王，type为5,index为1，则最终的key为51,value是一个数组，存放相同类型的牌
    for(var key in currentCards)
    {
        var oneCardIndex =  currentCards[key];
        var realCard = GameHelper.getCard(oneCardIndex);

        var typeKey = ""+realCard.cardType+realCard.cardNum;

        if(typeof (typeIndexMap[typeKey]) == "undefined")
        {
            typeIndexMap[typeKey] = [];
        }
        typeIndexMap[typeKey].push(oneCardIndex);
    }

    //1,2,3分别表示单牌，双牌，三张牌的集合
    var numsMap = {1:[],2:[],3:[]};

    for(var key in typeIndexMap)
    {
        var cards = typeIndexMap[key];
        var length = cards.length;
        numsMap[length].push(cards);
    }

    if(isFirst)
    {
        for(var i = 3;i>=1;i--)
        {
            var cards = numsMap[""+i];
            for(var k1 = 0;k1<cards.length;k1++)
            {
                canHitCards.push(cards[k1]);
            }

        }
    }
    else
    {
        var otherCards = [];//不是和出牌的牌类型相同的牌
        var goodCards = [];//和第一个出的牌类型一样的牌
        var tempCardType = GameHelper.getCardType(tempCardIndex,keyNum,mainType);
        for(var key in currentCards)
        {
            var oneCardIndex = currentCards[key];
            var oneCardType = GameHelper.getCardType(oneCardIndex,keyNum,mainType);
            if(tempCardType == oneCardType)
            {
                goodCards.push(oneCardIndex);
            }
            else
            {
                otherCards.push(oneCardIndex);
            }
        }

        var goodNum = goodCards.length;

        if(goodNum >= cardNum)//相同类型的牌够
        {
            if(cardNum==1)
            {
                for(var key in goodCards)
                {
                    canHitCards.push([goodCards[key]]);
                }
            }
            else
            {
                //所有的牌进行组合，并将牌进行排序，一样的牌优先级较高
                canHitCards = GameHelper.combineArray(goodCards,cardNum);
                //将牌进行排列组合
            }
        }
        else if(goodNum>0&&goodNum<cardNum)//相同类型的牌不够
        {
            canHitCards = GameHelper.combineArray1(goodCards,otherCards,cardNum);
        }
        else//没有相同类型的牌
        {
            canHitCards = GameHelper.combineArray(otherCards,cardNum);
        }
    }

    //进行提示排序
    canHitCards = GameHelper.sortCardArray(canHitCards,mainType,keyNum);
    return canHitCards;
}


//游戏中用到的牌
function Card()
{
    this.cardType = 0;
    this.cardNum = 0;
}

//游戏中用到的分配的Cars
function AssignCards()
{
    this.assignCars = [];
    for(var i = 0;i<4;i++)
    {
        this.assignCars[i] = [];
    }
    this.remain = [];
}



