/**
 * Created by Administrator on 2015/8/25.
 */
var HallUILayer = cc.Layer.extend({
    ctor:function () {
        //////////////////////////////
        // 1. super init first
        this._super();
        var self = this;
        GuiController.HallUI = this;
        GuiController.CurrentUI = this;
        g_GameNetWork = GameGloble.g_webSocketClient;


        this.tableMap = {};
        this.playerTableMap = {};
        this.chairIDWithPosMap = {"top1":"top","left1":"left","bottom1":"bottom","right1":"right"};
        var mainScene = ccs.load(res.HallUI).node;
        this.addChild(mainScene);

        this.tableView = mainScene.getChildByName("TableView");
        this.tableViewSize = this.tableView.getSize();

        this.tableTemp = this.tableView.getChildByName("TableTemp");
        this.tableTemp.setVisible(false);

        this.waitingUI = mainScene.getChildByName("WaitingUI");
        GuiController.showWaitingUI(this.waitingUI,"正在初始化大厅请稍后...",Number.MAX_VALUE);
        this.normalMessage = GuiController.initNormalMessageUI(mainScene);
        GuiController.initQuitGameUI(mainScene);//返回键退出游戏
        //点击快�?�开�?
        var quickBn = mainScene.getChildByName("QuickStart");
        CocosHeler.setOnClickEvent(quickBn,function()
        {
            g_GameNetWork.crossSendData('quickentergame',{});
            g_SoundManager.playHitMenuSound();
            //显示等待进入界面
            GuiController.showWaitingUI(this.waitingUI,"正在与服务器通信...",Number.MAX_VALUE);
        },this);

        //点击返回
        var backBn = mainScene.getChildByName("Back");
        CocosHeler.setOnClickEvent(backBn,function()
        {
            g_SoundManager.playHitMenuSound();
            g_GameNetWork.crossSendData("playerLeavehall",{});
            cc.director.runScene(new ChooseGameUIScene());
        });

        //获取声音按钮
        this.playMusicBn = mainScene.getChildByName("ShengyinBn");
        this.playMusicBn.setSelected(!g_SoundManager.canPlaySound);
        CocosHeler.setOnClickEvent(this.playMusicBn,function(item)
        {
            g_SoundManager.playHitMenuSound();
            if(item.isSelected() == false)
            {
                g_SoundManager.stopAllSound();
            }
            else
            {
                g_SoundManager.setCanPlaySound(false);//其他界面都不是在玩游�?,�?以直接设置为false
            }
        },this);

        var tableNums =  GameGloble.HallsTablesNums[GameGloble.HallID];
        self.addTalbes(tableNums);
        var socketClient = GameGloble.g_webSocketClient;
        //监听网络连接事件
        socketClient.onConnectEvent.addEventListener("HallUI",function()
        {
            //断开连接后又连上了，重新连接服务器
            GameGloble.reloginServer();
        });
        socketClient.onReloginEvent.addEventListener("HallUI",function()
        {
            cc.director.runScene(new HallUIScene());
        });
        socketClient.onCloseEvent.addEventListener("HallUI",function()
        {
            GuiController.showWaitingUI(self.waitingUI,"网络不稳定，正在重新连接服务器...",Number.MAX_VALUE);
        });
        g_GameNetWork.crossSendData("tableinfo",{hallID:GameGloble.HallID});
    },
    addTalbes:function(tableNums)
    {
        var totalWidth = 0;
        for(var i = 0,countTimes = 0;i<tableNums;i+=2,countTimes+=1)
        {
            var x = countTimes*350+50;
            totalWidth += 350;

            var topTable = this.tableTemp.clone();
            topTable.setVisible(true);
            topTable.setPositionX(x);
            topTable.setPositionY(300);
            var topTableNum = i;
            var numText = topTable.getChildByName("TableNum");  //topTable.getChildByName("TableNum");
            numText.setString(topTableNum);
            this.tableView.addChild(topTable);
            topTable.tableID = topTableNum;
            this.tableMap[topTableNum] =  topTable;

            this.setTableChairImageClick(topTable);



            var bottomTable = this.tableTemp.clone();
            bottomTable.setVisible(true);
            bottomTable.setPositionX(x);
            bottomTable.setPositionY(50);
            var bottomTableNum = i+1;
            numText = bottomTable.getChildByName("TableNum");
            numText.setString(bottomTableNum);
            this.tableView.addChild(bottomTable);
            bottomTable.tableID = bottomTableNum;
            this.tableMap[bottomTableNum] =  bottomTable;

            this.setTableChairImageClick(bottomTable);
        }
        this.tableView.setInnerContainerSize(cc.size(totalWidth,this.tableViewSize.height));
    },
    showOnePlayer:function(playerAccount,playerName,playerHeadURL,tableId,pos,loginType)
    {
        if(GameGloble.isMySelf(playerAccount))
        {
            GameGloble.Pos = pos;
            //进入游戏UI
            cc.director.runScene(new GameUIScene());
            return;
        }
        var tableUI = this.tableMap[tableId];
        var imageView = this.getHeadImageWithPos(tableUI,pos);
        imageView.loadTexture(playerHeadURL);
        imageView.setVisible(true);
        imageView.setOpacity(1000);
        var nameText = ccui.helper.seekWidgetByName(tableUI,""+pos+"Name");
        nameText.setString(playerName);
        nameText.setVisible(true);
        nameText.setOpacity(1000);
        var chairImage = this.getHeadImageWithPos(tableUI,pos+"1");
        chairImage.setVisible(false);
        //存储信息
        this.playerTableMap[playerAccount] ={tableid:tableId,pos:pos};
    },
    hideOnePlayer:function(account)
    {
        var tableData = this.playerTableMap[account];
        var tableID = tableData.tableid;
        var pos = tableData.pos;
        var tableUI = this.tableMap[tableID];
        var imageView = this.getHeadImageWithPos(tableUI,pos);
        imageView.setVisible(false);
        imageView.setOpacity(0);
        var nameText = this.getNameTextWithPos(tableUI,pos);
        nameText.setVisible(false);
        nameText.setOpacity(0);
        var chairImage = this.getHeadImageWithPos(tableUI,pos+"1");
        chairImage.setVisible(true);
    },
    getHeadImageWithPos:function(tableUINode,pos)
    {
        var imageView = tableUINode.getChildByName(pos.toString());
        return imageView;
    },
    getNameTextWithPos:function(tableUINode,pos)
    {
        var nameText = tableUINode.getChildByName(pos.toString()+"Name");
        return nameText;
    },
    setTableChairImageClick:function(tableUi)
    {
        var self = this;
        for(var key in self.chairIDWithPosMap)
        {
            var pos = self.chairIDWithPosMap[key];
            var imageView = this.getHeadImageWithPos(tableUi,key);
            imageView.pos = pos;
            CocosHeler.setOnClickEvent(imageView,function(wiget)
            {
                var table = wiget.getParent();
                //显示等待界面
                GuiController.showWaitingUI(self.waitingUI,"正在进桌...",Number.MAX_VALUE);
                //发�?�进入桌子的信息
                var sendData = {hallID:GameGloble.HallID,tableid:table.tableID,pos:wiget.pos,pa:GameGloble.UserAccount};
                g_GameNetWork.crossSendData('playerintable',sendData);
            },this);
        }
    },
    clearUI:function()
    {
        for(var key in this.tableMap)
        {
            var tableUI = this.tableMap[key];
            for(var key in this.chairIDWithPosMap)
            {
                var pos = this.chairIDWithPosMap[key];
                var imageView = this.getHeadImageWithPos(tableUI,key);
                imageView.setVisible(false);
            }
        }
        this.playerTableMap = {};
    },
    onExit:function()
    {
        this._super();
        GameGloble.g_webSocketClient.onReloginEvent.removeListener("HallUI");
        GameGloble.g_webSocketClient.onCloseEvent.removeListener("HallUI");
        GameGloble.g_webSocketClient.onConnectEvent.removeListener("HallUI");
    }
});



var HallUIScene = cc.Scene.extend({
    onEnter:function () {
        this._super();

        this.layer = new HallUILayer();

        this.addChild(this.layer);
    }
});



//var HallUISceneInstance = null;
//HallUIScene.getInstanceAndClearUI = function()
//{
//    HallUISceneInstance = HallUISceneInstance || new HallUIScene();
//    HallUISceneInstance.hallUILayer.clearUI();
//}
