/**
 * Created by litengfei on 16/3/26.
 */
/**
 * Created by Administrator on 2016/1/13.
 */

var NewUpdateUILayer = cc.Layer.extend({
    sprite:null,
    ctor:function () {
        //////////////////////////////
        // 1. super init first
        this._super();
        var mainScene = ccs.load("res1/AssetsUpdateUI.json").node;
        this.addChild(mainScene);

        this.infoText = mainScene.getChildByName("InfoText");//提示字符

        var storagePath = (jsb.fileUtils ? jsb.fileUtils.getWritablePath() : "./");
        cc.log("storagePath is " + storagePath);

        this._am = new jsb.AssetsManager("res1/project.manifest", storagePath);
        this._am.retain();
        if (!this._am.getLocalManifest().isLoaded()) {
            cc.log("Fail to update assets, step skipped.");
            this.loadGame();
        }
        else {
            var that = this;
            var listener = this.listener = new jsb.EventListenerAssetsManager(this._am, function (event) {

                switch (event.getEventCode()) {

                    case jsb.EventAssetsManager.ERROR_NO_LOCAL_MANIFEST:
                        cc.log("No local manifest file found, skip assets update.");
                        break;

                    case jsb.EventAssetsManager.UPDATE_PROGRESSION:

                        that._percent = event.getPercent();
                        that._percent = new Number(that._percent);
                        that._percent = that._percent == 0?10:that._percent;
                        that.infoText.setString("正在更新" + that._percent.toFixed(2) + "%");
                        var msg = event.getMessage();

                        if (msg) {

                            cc.log(msg);

                        }

                        break;

                    case jsb.EventAssetsManager.ERROR_DOWNLOAD_MANIFEST:

                    case jsb.EventAssetsManager.ERROR_PARSE_MANIFEST:

                        cc.log("Fail to download manifest file, update skipped.");

                        break;

                    case jsb.EventAssetsManager.ALREADY_UP_TO_DATE:
                        cc.log("ALREADY_UP_TO_DATE.");
                        that.loadGame();
                        break;

                    case jsb.EventAssetsManager.UPDATE_FINISHED:

                        cc.log("Update finished.");
                        that.loadGame();
                        break;

                    case jsb.EventAssetsManager.UPDATE_FAILED:

                        cc.log("Update failed. " + event.getMessage());

                        failCount++;

                        if (failCount < maxFailCount) {

                            that._am.downloadFailedAssets();

                        }

                        else {
                            cc.log("Reach maximum fail count, exit update process");
                            failCount = 0;
                            that.loadGame();
                        }

                        break;

                    case jsb.EventAssetsManager.ERROR_UPDATING:

                        cc.log("Asset update error: " + event.getAssetId() + ", " + event.getMessage());
                        var errorString = "Asset update error: " + event.getAssetId() + ", " + event.getMessage();
                        break;

                    case jsb.EventAssetsManager.ERROR_DECOMPRESS:
                        cc.log(event.getMessage());
                        break;
                    default:
                        break;
                }
            });
            cc.eventManager.addListener(listener, 1);
            this._am.update();
            return true;
        }
    },
    loadGame:function(){
        //jsList是jsList.js的变量，记录全部js。
        var self = this;
        cc.loader.loadJs(["src1/files.js"], function(){
            cc.loader.loadJs(jsFiles, function(){
                cc.LoaderScene.preload([res.LoadingUI], function () {
                    cc.director.runScene(new LoadingUIScene());
                    // runSocketIOTest();
                }, self);
            });
        });

    },
    updateProgress:function(dt){
    },
    onExit:function(){
        try
        {
            this._super();
            cc.log("AssetsManager::onExit");
            this._am.release();
            if(typeof this.listener == "undefined")return;
            cc.eventManager.removeListener(this.listener);

        }catch (e)
        {

        }
    },
    setOnClickEvent:function(wiget,callBack,content)
    {
        wiget.addTouchEventListener(function(select,type)
        {
            switch(type)
            {
                case ccui.Widget.TOUCH_BEGAN :
                    callBack.call(content,wiget);
                    return true;
            }
        },this);
    }
});

var NewUpdateUIScene = cc.Scene.extend({
    onEnter:function () {
        this._super();
        var layer = new NewUpdateUILayer();
        this.addChild(layer);
    }
});

