/**
 * Created by Administrator on 2015/9/26.
 */

//声音播放
function SoundManager()
{
    //初始化声音
    this.canPlaySound = true;//是否可以播放声音的变量
    this.canPlayMusic = true;//是否可以播放音乐的变量
    this.baseUrl = GameGloble.ResPath+"Sounds/";
    this.currentMusic = "";
    this.audioEngine = cc.audioEngine;
    this.audioEngine.setMusicVolume(0.3);
}

SoundManager.prototype.getSoundUrl = function(soundName)
{
    return this.baseUrl + soundName;
}
SoundManager.prototype.playNormalBackGround = function()
{
    if(this.canPlayMusic == false)return;
    if(this.currentMusic == "NormalMusic")return;
    this.currentMusic = "NormalMusic";
    this.audioEngine.playMusic(this.getSoundUrl("nomalback.mp3"),true);
}

SoundManager.prototype.playGameBackGround = function()
{
    if(this.canPlayMusic == false)return;
    if(this.currentMusic == "GameMusic")return;
    this.currentMusic = "GameMusic";
    //产生随机数
    var random = JSUseFullFramework.getRandomNum(1,2);
    var gamebackName = "gameback"+random+".mp3";
    this.audioEngine.playMusic(this.getSoundUrl(gamebackName),true);
}

SoundManager.prototype.stopAllSound = function()
{
    this.canPlaySound = false;
    //停止播放背景音乐
    this.audioEngine.stopMusic(false);
    this.audioEngine.stopAllEffects();
}

SoundManager.prototype.setCanPlaySound = function(canPlaySound)
{
    this.canPlaySound = canPlaySound;
}

//设置可以播放音乐
SoundManager.prototype.setCanPlayMusic = function(isGameing,canPlayMusic)
{
    this.canPlayMusic = canPlayMusic;
    if(canPlayMusic == false)
    {
     this.audioEngine.stopMusic(false);
     this.currentMusic = "";
     return;
    };
    if(isGameing == true)
    {
        this.playGameBackGround();
    }
    else
    {
        this.playNormalBackGround();
    }
}

//播放发牌的声音
SoundManager.prototype.playDealCardSound = function()
{
    if(this.canPlaySound == false)return;
    this.audioEngine.playEffect(this.getSoundUrl("fapai.mp3"),false);
}

//播放杀的声音
SoundManager.prototype.playShaSound = function(sex)
{
    if(this.canPlaySound == false)return;
    var sexPath = sex == 1?"Man":"Women";
    var finalPath = sexPath+"/HitCard/";
    var random  = JSUseFullFramework.getRandomNum(1,2);
    var soundName = finalPath+random+"sha_"+sex+".mp3";
    this.audioEngine.playEffect(this.getSoundUrl(soundName),false);
}
//播放出牌的声音
SoundManager.prototype.playHitCardSound = function(sex,cardIndexs)
{
    if(this.canPlaySound == false)return;
    var sexPath = sex == 1?"Man":"Women";
    var finalPath = sexPath+"/HitCard/";
    var sameCard = GameHelper.isSameCard(cardIndexs);
    if(sameCard == false)
    {
        var ranDome = JSUseFullFramework.getRandomNum(1,3);
        finalPath+=ranDome+"liula_"+sex+".mp3";
        this.audioEngine.playEffect(this.getSoundUrl("hitcard.mp3"),false);
        this.audioEngine.playEffect(this.getSoundUrl(finalPath),false);
        return;
    }
    else
    {
        var hitType = "";
        var cardCount = cardIndexs.length;
        if(cardCount == 2)hitType = "d";
        if(cardCount == 3)hitType = "l";
        var card =  GameHelper.getCard(cardIndexs[0]);
        var cardNum = card.cardNum;
        var cardType = card.cardType;
        if(cardType == 5 && cardNum == 1)cardNum = 14;
        if(cardType == 5 && cardNum == 2)cardNum = 15;
        var cardPath = hitType+cardNum+"_"+sex+".mp3";
        finalPath+=cardPath;
        this.audioEngine.playEffect(this.getSoundUrl("hitcard.mp3"),false);
        this.audioEngine.playEffect(this.getSoundUrl(finalPath),false);
    }
}

//播放吐槽的声音
SoundManager.prototype.playTuCao = function(sex,tucaoIndex)
{
    if(this.canPlaySound == false)return;
    var soundName = tucaoIndex+"_"+sex+".mp3";
    this.audioEngine.playEffect(this.getSoundUrl(soundName),false);
}

//播放结束游戏的声音
SoundManager.prototype.playGameFinishSound = function(isWin)
{
    if(this.canPlaySound == false)return;
    if(isWin == true)
    {
        this.audioEngine.playEffect(this.getSoundUrl("win.mp3"),false);
    }
    else
    {
        this.audioEngine.playEffect(this.getSoundUrl("lose.mp3"),false);
    }
}
//播放称号升级的声音

SoundManager.prototype.playPowerUpSound = function()
{
    if(this.canPlaySound == false)return;
    this.audioEngine.playEffect(this.getSoundUrl("powerup.mp3"),false);
}

//播放点击菜单的声音
SoundManager.prototype.playHitMenuSound = function()
{
    if(this.canPlaySound == false)return;
    this.audioEngine.playEffect(this.getSoundUrl("clickmenu.mp3"),false);
}

//播放点击菜单的声音
SoundManager.prototype.playClickMenuSound = function()
{
    if(this.canPlaySound == false)return;
    var sound = this.audioEngine.playEffect(this.getSoundUrl("hitmenu.mp3"),false);
    this.audioEngine.setEffectsVolume(1);
}

//播放菜单出来的声音
SoundManager.prototype.playShowMenuSound = function()
{
    if(this.canPlaySound == false)return;
    this.audioEngine.playEffect(this.getSoundUrl("showmenu.mp3"),false);
}

//播放点击商城的声音
SoundManager.prototype.playShangcheng = function()
{
    if(this.canPlaySound == false)return;
    this.audioEngine.playEffect(this.getSoundUrl("shangcheng.mp3"),false);
}

//播放定主
SoundManager.prototype.playDingzhu = function(sex)
{
    if(this.canPlaySound == false)return;
    var sound = "dingzhu_"+sex+".mp3";
    this.audioEngine.playEffect(this.getSoundUrl(sound),false);
}
//播放反主
SoundManager.prototype.playFanzhu = function(sex)
{
    if(this.canPlaySound == false)return;
    var sound = "fanzhu_"+sex+".mp3";
    this.audioEngine.playEffect(this.getSoundUrl(sound),false);
}

var g_SoundManager = null;

