/**
 * Created by Administrator on 2015/9/29.
 */
/**
 * Created by Administrator on 2015/9/29.
 */

var UpdateLayer = cc.Layer.extend({
    ctor:function () {
        this._super();
        this._progress = new cc.LabelTTF.create("正在检查配置文件...", "Arial", 30);
        this ._progress.x = cc.winSize.width / 2;
        this._progress.y = cc.winSize.height / 2;
        this.addChild(this._progress);

        var storagePath = (jsb.fileUtils ? jsb.fileUtils.getWritablePath() : "./");

        cc.log("storagePath is " + storagePath);

        this._am = new jsb.AssetsManager("res/project.manifest", storagePath);
        this._am.retain();

        if (!this._am.getLocalManifest().isLoaded())
        {
            cc.log("Fail to update assets, step skipped.");
            this.loadGame();
        }
        else
        {
            var that = this;
            cc.EventListenerAssetsManager
            var listener = new jsb.EventListenerAssetsManager(this._am, function(event) {

                switch (event.getEventCode()){

                    case jsb.EventAssetsManager.ERROR_NO_LOCAL_MANIFEST:
                        cc.log("No local manifest file found, skip assets update.");
                        break;

                    case jsb.EventAssetsManager.UPDATE_PROGRESSION:

                        that._percent = event.getPercent();
                        that._percent = new Number(that._percent);
                        that._progress.setString("正在更新"+that._percent+"%");
                        var msg = event.getMessage();

                        if (msg) {

                            cc.log(msg);

                        }

                        break;

                    case jsb.EventAssetsManager.ERROR_DOWNLOAD_MANIFEST:

                    case jsb.EventAssetsManager.ERROR_PARSE_MANIFEST:

                        cc.log("Fail to download manifest file, update skipped.");
                        break;

                    case jsb.EventAssetsManager.ALREADY_UP_TO_DATE:
                        cc.log("ALREADY_UP_TO_DATE.");
                        that.loadGame();
                        break;

                    case jsb.EventAssetsManager.UPDATE_FINISHED:

                        cc.log("Update finished.");
                        that.loadGame();
                        break;

                    case jsb.EventAssetsManager.UPDATE_FAILED:

                        cc.log("Update failed. " + event.getMessage());

                        failCount++;

                        if (failCount < maxFailCount)

                        {

                            that._am.downloadFailedAssets();

                        }

                        else

                        {
                            cc.log("Reach maximum fail count, exit update process");
                            failCount = 0;
                            that.loadGame();
                        }

                        break;

                    case jsb.EventAssetsManager.ERROR_UPDATING:

                        cc.log("Asset update error: " + event.getAssetId() + ", " + event.getMessage());
                        var errorString = "Asset update error: " + event.getAssetId() + ", " + event.getMessage();
                        break;

                    case jsb.EventAssetsManager.ERROR_DECOMPRESS:
                        cc.log(event.getMessage());
                        break;
                    default:
                        break;
                }
            });

            cc.eventManager.addListener(listener, 1);
            this._am.update();
        }
    },

    loadGame:function(){
        //jsList是jsList.js的变量，记录全部js。
        var self = this;
        cc.loader.loadJs(["src/files.js"], function(){
            cc.loader.loadJs(jsFiles, function(){
                cc.LoaderScene.preload([res.LoadingUI], function () {
                    cc.director.runScene(new LoadingUIScene());
                    // runSocketIOTest();
                }, this);
            });
        });

    },

    updateProgress:function(dt){
    },

    onExit:function(){
        try
        {
            cc.log("AssetsManager::onExit");
            this._am.release();
            this._super();
        }catch (e)
        {

        }
    }
});

var UpdateScene = cc.Scene.extend({
    onEnter:function () {
        this._super();
        var layer = new UpdateLayer();
        this.addChild(layer);
    }
});

