/**
 * Created by Administrator on 2016/1/17.
 */
var WebSocket =  WebSocket || window.WebSocket || window.MozWebSocket;
function WebSocketClient(uri)
{
    this.uri = uri;
    this.isConnected = false;
    this.eventManager = {};
    this.onConnectEvent = new EventListenerManager();
    this.onCloseEvent = new EventListenerManager();
    this.onReloginEvent = new EventListenerManager();//重新登录事件
    this.connectAndinit();
    this.checkAndAutoConnect();
}

WebSocketClient.prototype.connectAndinit = function()
{
    var self = this;
    this.client = new WebSocket(this.uri);
    this.client.onopen = function(evt)
    {
        self.isConnected = true;
        self.doEvent("connect",{});
        self.onConnectEvent.notifyEvent();
    }
    this.client.onmessage = function(evt)
    {
        try{
            var dataJson = JSON.parse(evt.data);
            self.doEvent(dataJson.eventname,dataJson);
        }catch(e)
        {
            cc.log(e.message);
        }
    }
    this.client.onclose = function(evt)
    {
        if(self.isConnected == true)//防止多次响应该事件
        {
            self.client.close();
            self.doEvent("close",{});
            self.onCloseEvent.notifyEvent();
        }
        self.isConnected = false;
    }

    this.client.onerror = function(evt)
    {

    }
}

WebSocketClient.prototype.checkAndAutoConnect = function()
{
    var self = this;
    setInterval(function()
    {
        if(self.isConnected == true)return;
        self.connectAndinit();
    },3000);
}

WebSocketClient.prototype.on = function(eventName,eventCallback)
{
    this.eventManager[eventName] = eventCallback;
}

WebSocketClient.prototype.doEvent = function(eventName,jsonData)
{
    var eventCallback = this.eventManager[eventName];
    if(typeof eventCallback == "undefined" || eventCallback == null)return;
    eventCallback(jsonData);
}

WebSocketClient.prototype.crossSendData = function(eventName,data)
{
    try
    {
        data.eventname = eventName;
        this.client.send(JSON.stringify(data));
    }
    catch(e)
    {
        cc.log("发送数据错误"+ e.message);
    }

}

WebSocketClient.prototype.crossParseData = function(data)
{
    return data;
}

WebSocketClient.prototype.close = function()
{
    try
    {
        this.client.close();
        this.client.onclose(null);
    }
    catch(e){}
}